#pragma once

#include "Objects.h"
#include <vector>

using namespace std;


class CKinematics
{
public:
	CKinematics(int taskSize);
	~CKinematics(void);

	virtual dMatrix Forward () = 0;
	virtual dVector Error () = 0;
	virtual dMatrix Jacobian () = 0;
	virtual dVector NullSpace ();

	dVector GetDesired () { return _desired; }	//  ġ ȯѴ.
	dVector GetCurrent () { return _current; }	//  ġ ȯѴ.

	dVector SolveJTR (double minAlpha, double clampTask);						// Jacobian Transpose  Inverse kinematics Ǭ.
	dVector SolveDLS (double dlsLambda, double clampTask, double clampNull);	// Damped least square  Inverse kinematics Ǭ.
	void Apply (dVector &dq);					//  Ʈ ȸ(dq)  Ʈ (q) Ѵ.

	void AttachJoint (ObjectBase *joint);		// Ʈ   ϳ Ʈ Ѵ.

	vector<ObjectBase *> &GetObjectList () { return _objectList; }	// Ʈ  ִ  ´. (׸  )
	dVector GetJointAngle ();					//  Ʈ (q)  ȯѴ.

protected:
	vector<ObjectBase *> _objectList;

	dVector _desired;
	dVector _current;

	void ClampMag(dVector &w, double maxMag);
	dMatrix PseudoInverseWithDLS (dMatrix &J, double dlsLambda);

	double WeightFunction (double lo, double hi, double q);
	dMatrix WeightMatrix (unsigned int dof);
};
