#pragma once

#include "Kinematics.h"
#include <vector>

class CMultiTasks : public CKinematics
{
public:
	CMultiTasks(void);
	~CMultiTasks(void);

	virtual dMatrix Forward ();
	virtual dVector Error ();
	virtual dMatrix Jacobian ();

	// Chiaverini Nakamura ó ߰ task   .
	void AddTask (CKinematics *task);

	// Chiaverini  
	dVector SolveChi (double dlsLambda, double clampTask);
	// Nakamura  
	dVector SolveNak (double dlsLambda, double clampTask);

protected:
	vector<pair<CKinematics *, vector<unsigned int>> > _taskList;

private:
	dMatrix ReformMatrixByIndex (dMatrix &m, int colno, vector<unsigned int> &indexList);
	dVector AttachVector (dVector &a, dVector &b);
	int FindIndex (vector<ObjectBase *> &objectList, const string &name);
};
