//////////////////////////////////////////////////////
// Kinematics files for Robotics applications
// 
// Copyright (c) 2002-2010. All Rights Reserved.
// Division of Applied Robot Technology, KITECH
// Web: http://www.orobot.net
// Written by KwangWoong Yang<page365@gmail.com>
//

#include "StdAfx.h"
#include "Objects.h"

CTransformMatrix ObjectBase::TransformationMatrix ()
{
	return CTransformMatrix (_x, _y, _z, _phi, _theta, _psi);
}

CTransformMatrix ObjectJoint::TransformationMatrixQ ()
{
	if (_type == PRISMATIC_JOINT){
		if (_axis == 0)      return CTransformMatrix (_q, 0, 0, 0, 0, 0);
		else if (_axis == 1) return CTransformMatrix (0, _q, 0, 0, 0, 0);
		else if (_axis == 2) return CTransformMatrix (0, 0, _q, 0, 0, 0);
	}
	else if (_type == REVOLUTE_JOINT) {
		if (_axis == 0)      return CTransformMatrix (0, 0, 0, _q, 0, 0);
		else if (_axis == 1) return CTransformMatrix (0, 0, 0, 0, _q, 0);
		else if (_axis == 2) return CTransformMatrix (0, 0, 0, 0, 0, _q);
	}

	return CTransformMatrix (0, 0, 0, 0, 0, 0);
}

CTransformMatrix ObjectJoint::TransformationMatrix ()
{
	return TransformationMatrixQ() * CTransformMatrix (_x, _y, _z, _phi, _theta, _psi);
}
