//////////////////////////////////////////////////////
// OpenGL files for Robotics applications
// 
// Copyright (c) 2002-2010. All Rights Reserved.
// Division of Applied Robot Technology, KITECH
// Web: http://www.orobot.net
// Written by KwangWoong Yang<page365@gmail.com>
//

#pragma once
#include "OglWnd.h"
#include "ObjectContainer.h"
#include "OglObjects.h"

class COglWndCustom : public COglWnd
{
public:
	COglWndCustom (CObjectContainer *objs);

	virtual void OnDraw(CDC* pDC);

	bool _showAxis;

private:
	CObjectContainer *_objs;

	void TransformAxis(dMatrix &A);
	void DrawRevLink (double x, double y, double z, double radius);

	void DrawFixedJoint (ObjectJoint *joint);
	void DrawRevoluteJoint (ObjectJoint *joint);
	void DrawPrismaticJoint (ObjectJoint *joint);
	void DrawLine (ObjectLine *o) { oglLine (0, 0, 0, 0, 0, o->_length); }
	void DrawSphere (ObjectSphere *o) { oglSphere (o->_radius); }
	void DrawCapsule (ObjectCapsule *o) { oglCapsule (o->_height, o->_radius); }
	void DrawCylinder (ObjectCylinder *o) { oglCylinder (o->_height, o->_radius); }
	void DrawBox (ObjectBox *o) { oglBox (o->_dx, o->_dy, o->_dz); }

	void RenderJoint();
};
