
// TaskPriorityDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TaskPriority.h"
#include "TaskPriorityDlg.h"
#include "MathDef.h"
#include "PosOriInverse.h"
#include "OglWndCustom.h"
#include "ObjectContainer.h"
#include "MultiTasks.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#pragma warning(disable:4996)

#define DLG_ITEMS_HEIGHT		90

// CTaskPriorityDlg dialog

CTaskPriorityDlg::CTaskPriorityDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTaskPriorityDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	_inv1 = NULL;
	_inv2 = NULL;
	_objs = NULL;
	_view = NULL;
	_tasks = NULL;
}

void CTaskPriorityDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CTaskPriorityDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_WM_TIMER()
END_MESSAGE_MAP()


// CTaskPriorityDlg message handlers

BOOL CTaskPriorityDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	_objs = new CObjectContainer ();

	_objs->Push ();
	_objs->AddObject (new ObjectJoint (ObjectBase(REVOLUTE_JOINT,	"link1",	0xA0A0A0,	0., 0., 0.1,	0*_DEG2RAD, 0*_DEG2RAD, 0*_DEG2RAD), 2,	0.03,	-120*_DEG2RAD,	120*_DEG2RAD,	0*_DEG2RAD,	1.));
	_objs->AddObject (new ObjectJoint (ObjectBase(REVOLUTE_JOINT, 	"link2",	0xA0A0A0,	0., 0., 0.3,	0*_DEG2RAD, 0*_DEG2RAD, 0*_DEG2RAD), 1,	0.03,	-120*_DEG2RAD,	120*_DEG2RAD,	0*_DEG2RAD,	1.));
	_objs->AddObject (new ObjectJoint (ObjectBase(REVOLUTE_JOINT, 	"link3",	0xA0A0A0,	0., 0., 0.3,	0*_DEG2RAD, 0*_DEG2RAD, 0*_DEG2RAD), 0,	0.03,	-120*_DEG2RAD,	120*_DEG2RAD,	0*_DEG2RAD,	1.));
	_objs->Push ();
	_objs->AddObject (new ObjectJoint (ObjectBase(REVOLUTE_JOINT, 	"link4a",	0xA0A0A0,	0., 0., 0.3,	0*_DEG2RAD, 0*_DEG2RAD, 0*_DEG2RAD), 1,	0.03,	-120*_DEG2RAD,	120*_DEG2RAD,	0*_DEG2RAD,	1.));
	_objs->AddObject (new ObjectJoint (ObjectBase(REVOLUTE_JOINT, 	"link5a",	0xA0A0A0,	0., 0., 0.3,	0*_DEG2RAD, 0*_DEG2RAD, 0*_DEG2RAD), 0,	0.03,	-120*_DEG2RAD,	120*_DEG2RAD,	0*_DEG2RAD,	1.));
	_objs->AddObject (new ObjectJoint (ObjectBase(REVOLUTE_JOINT, 	"eea",		0xA0A0A0,	0., 0., 0.2,	0*_DEG2RAD, 0*_DEG2RAD, 0*_DEG2RAD), 1,	0.03,	-120*_DEG2RAD,	120*_DEG2RAD,	0*_DEG2RAD,	1.));
	_objs->Pop ();
	_objs->Push ();
	_objs->AddObject (new ObjectJoint (ObjectBase(REVOLUTE_JOINT, 	"link4b",	0xA0A0A0,	0., 0., 0.3,	0*_DEG2RAD, 0*_DEG2RAD, 0*_DEG2RAD), 1,	0.03,	-120*_DEG2RAD,	120*_DEG2RAD,	0*_DEG2RAD,	1.));
	_objs->AddObject (new ObjectJoint (ObjectBase(REVOLUTE_JOINT, 	"link5b",	0xA0A0A0,	0., 0., 0.3,	0*_DEG2RAD, 0*_DEG2RAD, 0*_DEG2RAD), 0,	0.03,	-120*_DEG2RAD,	120*_DEG2RAD,	0*_DEG2RAD,	1.));
	_objs->AddObject (new ObjectJoint (ObjectBase(REVOLUTE_JOINT, 	"eeb",		0xA0A0A0,	0., 0., 0.2,	0*_DEG2RAD, 0*_DEG2RAD, 0*_DEG2RAD), 1,	0.03,	-120*_DEG2RAD,	120*_DEG2RAD,	0*_DEG2RAD,	1.));
	_objs->Pop ();
	_objs->Pop ();

	_objs->Push ();
	_objs->AddObject (new ObjectSphere (ObjectBase(SOLID_SPHERE, 	"target1",	0x0000FF,	0., 0., 0.,	0*_DEG2RAD, 0*_DEG2RAD, 0*_DEG2RAD), 0.03));
	_objs->Pop ();
	_objs->Push ();
	_objs->AddObject (new ObjectSphere (ObjectBase(SOLID_SPHERE, 	"target2",	0x00FF00,	0., 0., 0.,	0*_DEG2RAD, 0*_DEG2RAD, 0*_DEG2RAD), 0.03));
	_objs->Pop ();


	_inv1 = new CPosOriInverse (POSITION_ONLY);
	_inv1->AttachJoint (_objs->FindObject ("link1"));
	_inv1->AttachJoint (_objs->FindObject ("link2"));
	_inv1->AttachJoint (_objs->FindObject ("link3"));
	_inv1->AttachJoint (_objs->FindObject ("link4a"));
	_inv1->AttachJoint (_objs->FindObject ("link5a"));
	_inv1->AttachJoint (_objs->FindObject ("eea"));

	_inv2 = new CPosOriInverse (POSITION_ONLY);
	_inv2->AttachJoint (_objs->FindObject ("link1"));
	_inv2->AttachJoint (_objs->FindObject ("link2"));
	_inv2->AttachJoint (_objs->FindObject ("link3"));
	_inv2->AttachJoint (_objs->FindObject ("link4b"));
	_inv2->AttachJoint (_objs->FindObject ("link5b"));
	_inv2->AttachJoint (_objs->FindObject ("eeb"));

	_tasks = new CMultiTasks ();
	_tasks->AddTask (_inv1);
	_tasks->AddTask (_inv2);

	//    ġ ũ⸦ о´.
	CRect rect;
	GetClientRect(rect);

	// ȭ  Ʈѵ ǥϱ   ȮѴ.
	rect.top += DLG_ITEMS_HEIGHT;

	// ⱸ Ǯ̸  COglWndCustom Ŭ ü 
	_view = new COglWndCustom(_objs);
	_view->CreateEx(0, "#32770", "", WS_TABSTOP | WS_CHILD | WS_VISIBLE, rect, this, 0);
	_view->_showAxis = true;  // OpenGL ׿ ǥ(axis) ׸ 

	CheckDlgButton (IDC_RADIO1, BST_CHECKED);

	SetTimer (1000, 33, NULL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTaskPriorityDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTaskPriorityDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CTaskPriorityDlg::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);

	// TODO: Add your message handler code here
	if(_view) {
		_view->SetWindowPos(NULL, 0, 0, cx, cy - DLG_ITEMS_HEIGHT, SWP_NOMOVE|SWP_NOREPOSITION|SWP_NOZORDER );
	}
}

void CTaskPriorityDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: Add your message handler code here
	delete _tasks;
	delete _inv1;
	delete _inv2;
	delete _objs;
	delete _view;
}

void CTaskPriorityDlg::OnTimer(UINT_PTR nIDEvent)
{
	// κ end-effector ؾ  ǥ ġ ڼ Ѵ.
	double t = GetTickCount ()/1000.;
	double x1 = 0.0 + 0.7*sin(t*0.6);
	double y1 = 0.0 + 0.7*sin(t*0.7);
	double z1 = 0.5 + 0.7*sin(t*0.8);

	double x2 = 0.0 + 0.7*sin(t*0.4);
	double y2 = 0.0 + 0.7*sin(t*0.5);
	double z2 = 0.5 + 0.7*sin(t*0.6);

	// ǥ ġ ڼ Ѵ.
	_inv1->SetDesired (x1, y1, z1, 0, 0, 0);
	_inv2->SetDesired (x2, y2, z2, 0, 0, 0);
	
	if (IsDlgButtonChecked (IDC_RADIO1) == BST_CHECKED) {
		// ǥ ġ ڼ ϱ  DLS(Damped Least Square)  ⱸ Ǯ Ʈӵ(dq) ´.
		dVector dq = _tasks->SolveDLS (0.15, 0.1, 0.1);
		// Ʈġ Ʈӵ(dq) Ѵ.
		_tasks->Apply (dq);
	}
	else if (IsDlgButtonChecked (IDC_RADIO2) == BST_CHECKED) {
		dVector dq = _tasks->SolveChi (0.15, 0.1);
		// Ʈġ Ʈӵ(dq) Ѵ.
		_tasks->Apply (dq);
	}
	else if (IsDlgButtonChecked (IDC_RADIO3) == BST_CHECKED) {
		dVector dq = _tasks->SolveNak (0.15, 0.1);
		// Ʈġ Ʈӵ(dq) Ѵ.
		_tasks->Apply (dq);
	}

	// ȭڿ  ǥϱ   о, ڿ  ȭ Ʈѿ ǥѴ.
	_inv1->Forward ();	//  ġ Ʈ Ѵ.
	dVector d1 = _inv1->GetDesired ();	// ǥ ġ о´.
	dVector c1 = _inv1->GetCurrent ();	//  ġ о´.
	c1[3] = c1[4] = c1[5] = 0.;
	double  e1 = Norm2 (d1 - c1);			// ǥ ġ  ġ  Ÿ Ѵ.

	_inv2->Forward ();	//  ġ Ʈ Ѵ.
	dVector d2 = _inv2->GetDesired ();	// ǥ ġ о´.
	dVector c2 = _inv2->GetCurrent ();	//  ġ о´.
	c2[3] = c2[4] = c2[5] = 0.;
	double  e2 = Norm2 (d2 - c2);			// ǥ ġ  ġ  Ÿ Ѵ.

	int n;
	char buff[1024];

	sprintf (buff, "(% 6.3f, % 6.3f, % 6.3f), (% 6.3f, % 6.3f, % 6.3f)", d1[0], d1[1], d1[2], d2[0], d2[1], d2[2]);
	SetDlgItemText (IDC_EDIT_DESIRED, buff);

	sprintf (buff, "(% 6.3f, % 6.3f, % 6.3f), (% 6.3f, % 6.3f, % 6.3f)", c1[0], c1[1], c1[2], c2[0], c2[1], c2[2]);
	SetDlgItemText (IDC_EDIT_CURRENT, buff);

	sprintf (buff, "%f, %f", e1, e2);
	SetDlgItemText (IDC_EDIT_ERROR, buff);

	dVector ja1 = _tasks->GetJointAngle ();
	n = 0;
	for (unsigned int i=0; i<ja1.size(); i++) {
		n += sprintf (buff+n, "%5d,", (int)(_RAD2DEG*ja1[i]));
	}
	SetDlgItemText (IDC_EDIT_JOINTANGLE, buff);
	

	ObjectBase *t1 = _objs->FindObject ("target1");
	ObjectBase *t2 = _objs->FindObject ("target2");
	
	t1->_x = x1; t1->_y = y1; t1->_z = z1; 
	t2->_x = x2; t2->_y = y2; t2->_z = z2; 

	// OpenGL κ  ׸.
	_view->InvalidateRect (NULL, FALSE);

	CDialog::OnTimer(nIDEvent);
}
